> ## Documentation Index
> Fetch the complete documentation index at: https://docs.braintrust.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# List simulated users

> List simulated users in a project, ordered by UUID. Requires project read permission.



## OpenAPI

````yaml /openapi.yaml get /v1/project/{project_id}/simulated_user
openapi: 3.1.1
info:
  version: 1.0.0
  title: Braintrust API
  description: >-
    API specification for the backend data server. The API is hosted globally at

    https://api.braintrust.dev or in your own environment.


    You can access the OpenAPI spec for this API at
    https://github.com/braintrustdata/braintrust-openapi.
  license:
    name: Apache 2.0
servers:
  - url: https://api.braintrust.dev
security:
  - bearerAuth: []
  - {}
paths:
  /v1/project/{project_id}/simulated_user:
    get:
      tags:
        - Simulated users
      summary: List simulated users
      description: >-
        List simulated users in a project, ordered by UUID. Requires project
        read permission.
      operationId: listSimulatedUsers
      parameters:
        - schema:
            type: string
            format: uuid
          required: true
          name: project_id
          in: path
        - schema:
            anyOf:
              - type: string
                format: uuid
              - type: array
                items:
                  type: string
                  format: uuid
                maxItems: 1000
          required: false
          name: ids
          in: query
        - schema:
            type: string
          required: false
          name: simulated_user_name
          in: query
        - schema:
            $ref: '#/components/schemas/AppLimit'
          required: false
          description: Limit the number of objects to return
          name: limit
          in: query
        - $ref: '#/components/parameters/StartingAfter'
        - $ref: '#/components/parameters/EndingBefore'
      responses:
        '200':
          description: The matching simulated users
          content:
            application/json:
              schema:
                type: object
                properties:
                  objects:
                    type: array
                    items:
                      $ref: '#/components/schemas/SimulatedUser'
                required:
                  - objects
        '400':
          description: >-
            The request was unacceptable, often due to missing a required
            parameter
          content:
            text/plain:
              schema:
                type: string
            application/json:
              schema: {}
        '401':
          description: No valid API key provided
          content:
            text/plain:
              schema:
                type: string
            application/json:
              schema: {}
        '403':
          description: The API key doesn’t have permissions to perform the request
          content:
            text/plain:
              schema:
                type: string
            application/json:
              schema: {}
        '429':
          description: >-
            Too many requests hit the API too quickly. We recommend an
            exponential backoff of your requests
          headers:
            Retry-After:
              schema:
                type: string
          content:
            text/plain:
              schema:
                type: string
            application/json:
              schema: {}
        '500':
          description: Something went wrong on Braintrust's end. (These are rare.)
          content:
            text/plain:
              schema:
                type: string
            application/json:
              schema: {}
      security:
        - bearerAuth: []
        - {}
components:
  schemas:
    AppLimit:
      type:
        - integer
        - 'null'
      minimum: 0
      maximum: 1000
      default: 100
      description: Limit the number of objects to return
    SimulatedUser:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: Unique identifier for the simulated user
        _xact_id:
          type: string
          description: Legacy transaction id. Not returned by simulated user CRUD.
        project_id:
          type: string
          format: uuid
          description: >-
            Unique identifier for the project that the simulated user belongs
            under
        org_id:
          type: string
          format: uuid
          description: Unique identifier for the organization
        name:
          type: string
          minLength: 1
          description: Name of the simulated user
        created:
          type:
            - string
            - 'null'
          format: date-time
          description: Date of simulated user creation
        instructions:
          type: string
          minLength: 1
          description: The simulated user's role, scenario, and behavior
        goal:
          type: string
          minLength: 1
          description: >-
            The simulated user's objective, used to decide when to end the
            conversation
        voice_config:
          $ref: '#/components/schemas/SimulatedUserVoiceConfig'
      required:
        - id
        - project_id
        - org_id
        - name
        - instructions
        - voice_config
    StartingAfter:
      type: string
      format: uuid
      description: >-
        Pagination cursor id.


        For example, if the final item in the last page you fetched had an id of
        `foo`, pass `starting_after=foo` to fetch the next page. Note: you may
        only pass one of `starting_after` and `ending_before`
    EndingBefore:
      type: string
      format: uuid
      description: >-
        Pagination cursor id.


        For example, if the initial item in the last page you fetched had an id
        of `foo`, pass `ending_before=foo` to fetch the previous page. Note: you
        may only pass one of `starting_after` and `ending_before`
    SimulatedUserVoiceConfig:
      type: object
      properties:
        voice_id:
          type: string
          format: uuid
        language:
          type: string
          minLength: 1
        accent:
          type: string
          minLength: 1
        speaking_rate:
          type: number
          exclusiveMinimum: 0
      required:
        - voice_id
      additionalProperties: false
  parameters:
    StartingAfter:
      schema:
        $ref: '#/components/schemas/StartingAfter'
      required: false
      description: >-
        Pagination cursor id.


        For example, if the final item in the last page you fetched had an id of
        `foo`, pass `starting_after=foo` to fetch the next page. Note: you may
        only pass one of `starting_after` and `ending_before`
      name: starting_after
      in: query
    EndingBefore:
      schema:
        $ref: '#/components/schemas/EndingBefore'
      required: false
      description: >-
        Pagination cursor id.


        For example, if the initial item in the last page you fetched had an id
        of `foo`, pass `ending_before=foo` to fetch the previous page. Note: you
        may only pass one of `starting_after` and `ending_before`
      name: ending_before
      in: query
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: API key or JWT
      description: >-
        Most Braintrust endpoints are authenticated by providing your API key as
        a header `Authorization: Bearer [api_key]` to your HTTP request. You can
        create an API key in the Braintrust [organization settings
        page](https://www.braintrustdata.com/app/settings?subroute=api-keys).

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.